#ifndef __WINDOWS_H__
#define __WINDOWS_H__
#include "common.h"
#include "term.h"
#include "boxes.h"
#include "screens.h"
#include "text.h"
screen alloc_window(screen parent,int r, int c, int w, int h, boxstyle border, attributes border_att, 
                    char* title, attributes title_att, alignment title_align, void (draw)(screen),
                    void(run)(screen),void(dealloc)(screen));

#define w(a) ((window_data)(a->data))

#define define_window(name,w,h,border,border_att,title,title_att,title_align)  \
  static void on_draw(screen);                                                 \
  static void on_run (screen);                                                 \
  static void on_alloc(screen);                                                \
  static void on_dealloc(screen);                                              \
  screen alloc_window_##name(screen parent, int r, int c) {                    \
     screen ret = alloc_window(parent,r,c,w,h,border,border_att,title,         \
                                  title_att,title_align,on_draw,on_run,        \
                                  on_dealloc);                                 \
     on_alloc(ret);                                                            \
     return ret;                                                               \
  }

#define window_header(name)                                 \
  screen alloc_window_##name(screen parent, int r, int c);  \



#endif
